/*
 * MultiMail offline mail reader
 * 

 Written by Toth Istvan <stoty@vma.bme.hu>

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#ifndef ERROR_H
#define ERROR_H

#include "misc.h"
#include "mmail.h"

enum errortype { warning, retry, fatal };
class mmail;

class error
{
	mmail *mm;
	char *errorMsg;
	enum errortype type; 

public:
	error(mmail *mmA);

	void setErrorMsg(char* message);
	void setErrorType(const enum errortype typeA);

	char* getErrorMsg();
	const enum errortype getErrorType(); 

};

#endif // __ERROR_H
